<template>
  <nuxt-link v-if="!isAuthenticated"
             to="/login"
             class="lk-btn lk-btn--login">
    <icon-lock/>Войти
  </nuxt-link>

  <div v-else class="lk-btn__wrapper" :class="{'lk-btn__wrapper--tablet': !isMobile && isTouchDevice}">
    <nuxt-link
      to="/personal/profile"
      class="lk-btn lk-btn--lk"
      :class="{'lk-btn--active': isPageLK}"
    >
      <icon-user/> Личный кабинет
    </nuxt-link>

    <span
      @click="logout"
      class="lk-btn lk-btn--logout">
      <icon-logout/> Выйти
    </span>
  </div>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex';

  import IconLock from '../components/icons/IconLock';
  import IconUser from '../components/icons/IconUser';
  import IconLogout from '../components/icons/IconLogout';

  export default {
    name: 'LkBtn',
    props: {
      isMainPage: {
        type: Boolean,
        default: false
      },
    },
    components: {
      IconLock,
      IconUser,
      IconLogout
    },
    data: () => ({
      isTouchDevice: false,
    }),
    computed: {
      ...mapGetters({
        isAuthenticated: 'auth/isAuthenticated'
      }),

      isPageLK() {
        return this.$route.path.includes('/personal/')
      },

      isMobile() {
        return this.$store.state.isMobile;
      },
    },
    mounted() {
      this.isTouchDevice = 'ontouchstart' in window;

      window.addEventListener('resize', this.checkTouchDevice);
    },
    beforeDestroy() {
      window.removeEventListener('resize', this.checkTouchDevice);
    },
    methods: {
      ...mapActions({
        authLogout: 'auth/authLogout'
      }),

      logout() {
        this.authLogout();
        this.$router.push('/');
      },

      checkTouchDevice() {
        this.isTouchDevice = 'ontouchstart' in window;
      }
    }
  }
</script>

<style scoped lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .header--main {
    .lk-btn {
      color: $white;

      svg {
        stroke: $white;
        fill: $white;
      }
    }
  }

  .lk-btn {
    @include bold-black-link;
    @include main-link;

    display: flex;
    align-items: center;
    padding-left: rem(18);

    cursor: pointer;

    svg {
      margin-right: rem(12);
    }

    @media (max-width: $mobile-width) {
      padding-left: rem(40);

      font-size: rem(18);
    }

    &--login, &--lk {
      &:hover {
        svg {
          fill: #67D2C4;
          stroke: #67D2C4;
        }
      }
    }

    &--logout {
      display: none;
      color: #9098A9;
      left: 0;

      @media (max-width: $mobile-width) {
        display: flex;
        margin-top: rem(28);
      }

      &:hover {
        color: $black;

        svg {
          stroke: $black;
        }
      }
    }

    &.nuxt-link-active {
      color: $green;
    }

    &--active {
      color: $green;
    }

    &__wrapper {
      @media (min-width: $mobile-width + 1) {
        position: relative;

        display: flex;
        align-items: center;
        height: rem(50);

        &:not(.lk-btn__wrapper--tablet):hover {
          .lk-btn--lk {
            color: $green;
            opacity: .7;

            svg {
              fill: #67D2C4;
              stroke: #67D2C4;
            }

            &:hover {
              opacity: 1;
            }
          }

          .lk-btn--logout {
            display: flex;
            padding-top: rem(6);
            padding-bottom: rem(8);
            width: 100%;

            position: absolute;
            z-index: 1;
            top: 100%;
          }
        }
      }

      &--tablet {
        .lk-btn--logout {
          position: relative;
          top: 0;

          display: flex;

          &::before {
            content: '/';

            position: absolute;
            left: rem(6);
          }

          svg {
            display: none;
          }
        }
      }
    }
  }


</style>
